/**
 * JASMINe
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: DroolsUMOComponent.java 1118 2008-04-18 13:13:54Z loris $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eventswitch.endpoints;

import java.io.IOException;

import javax.naming.NamingException;

import org.ow2.jasmine.monitoring.eventswitch.beans.JasmineEventEB;
import org.ow2.jasmine.monitoring.eventswitch.beans.JasmineEventSFBRemote;
import org.ow2.jasmine.monitoring.eventswitch.messages.JasmineEvent;
import org.ow2.jasmine.monitoring.eventswitch.messages.JasmineEventDetails;

/**
 * An UMO component to insert JasmineEventEB objects into the working memory via EJB3.
 * @author Loris Bouzonnet
 */
public class DroolsUMOComponent extends MuleEJB3Wrapper<JasmineEventSFBRemote> {

    /**
     * Starts the {@link MuleEJB3Wrapper} in deferred mode.
     */
    public DroolsUMOComponent() {
        super(true);
    }

    public void saveJasmineEvent(final JasmineEvent jasmineEvent)
    throws NamingException, IOException {
        for(JasmineEventDetails jasmineEventDetails: jasmineEvent.getEvents()) {
            getBean().saveEvent(
                    new JasmineEventEB(
                            jasmineEvent.getDomain(),
                            jasmineEvent.getServer(),
                            jasmineEventDetails.getSource(),
                            jasmineEventDetails.getProbe(),
                            jasmineEventDetails.getValue(),
                            jasmineEventDetails.getTimestamp(),
                            jasmineEventDetails.getSname()));
        }
    }

}