package org.ow2.jasmine.monitoring.eventswitch.transformers;

import java.util.List;

import org.mule.transformers.AbstractTransformer;
import org.mule.umo.transformer.TransformerException;
import org.ow2.jasmine.monitoring.eventswitch.messages.JasmineEvent;
import org.ow2.jasmine.monitoring.eventswitch.messages.JasmineEventDetails;

public class JasmineEventToCSV extends AbstractTransformer {

    /**
     * Registers the transformer on Mule.
     *
     * @see org.mule.transformers.AbstractTransformer
     */
    public JasmineEventToCSV() {
        super();
        this.registerSourceType(JasmineEvent.class);
        this.setReturnClass(String.class);
    }


    /**
     * Transforms a JASMINe event into CVS string.
     *
     * @param src      @see org.mule.transformers.AbstractTransformer.doTransform
     * @param encoding @see org.mule.transformers.AbstractTransformer.doTransform
     *
     * @return src transformed into a CSV string.
     */
    @Override
    protected Object doTransform(Object src, String encoding) throws TransformerException {
        JasmineEvent event = (JasmineEvent) src;
        String result = "";

        String split = ";";

        String domain = event.getDomain();
        String server = event.getServer();

        List<JasmineEventDetails> eventDetailsList = event.getEvents();

        result = result + eventDetailsList.get(0).getTimestamp().getTime() + split
                + eventDetailsList.get(0).getTimestamp() + split
                + eventDetailsList.get(0).getSname() + split
                + domain + split
                + server + split
                + eventDetailsList.get(0).getProbe() + split;

        for (JasmineEventDetails ed : event.getEvents()) {
            result += ed.getValue() + split;
        }
        result += "\n";
        return result;
    }



}
